VERSION 5.00
Begin VB.Form FFreeMemRegList 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "List or free address-space areas"
   ClientHeight    =   5025
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9960
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5025
   ScaleWidth      =   9960
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstFreeRegs 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4620
      Left            =   75
      TabIndex        =   0
      Top             =   135
      Width           =   9780
   End
End
Attribute VB_Name = "FFreeMemRegList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MEM_FREE As Long = &H10000

Private Type MEMORY_BASIC_INFORMATION
     BaseAddress As Long
     AllocationBase As Long
     AllocationProtect As Long
     RegionSize As Long
     State As Long
     Protect As Long
     lType As Long
End Type

Private Declare Function VirtualQuery Lib "kernel32" (lpAddress As Any, lpBuffer As MEMORY_BASIC_INFORMATION, ByVal dwLength As Long) As Long

Private Sub Form_Load()
    Dim MemRgn As MEMORY_BASIC_INFORMATION
    
    Do While VirtualQuery(ByVal MemRgn.BaseAddress + MemRgn.RegionSize, MemRgn, Len(MemRgn))
        If MemRgn.State = MEM_FREE And MemRgn.BaseAddress <> 0 Then
            InsertFreeRegion MemRgn
        End If
    Loop
End Sub

Private Sub InsertFreeRegion(ByRef rgn As MEMORY_BASIC_INFORMATION)
    Dim iNewIndex As Long
    
    With lstFreeRegs
        Do While iNewIndex < .ListCount
            If rgn.RegionSize > .ItemData(iNewIndex) Then Exit Do
            iNewIndex = iNewIndex + 1
        Loop
    
        .AddItem GiveNiceSize(rgn.RegionSize) & " of free bytes in range " & _
                 GiveNiceAddr(rgn.BaseAddress) & "..." & _
                 GiveNiceAddr(rgn.BaseAddress + rgn.RegionSize - 1), _
                 iNewIndex
        .ItemData(iNewIndex) = rgn.RegionSize
    End With
End Sub

Private Function GiveNiceAddr(ByVal dw As Long) As String
    GiveNiceAddr = Right$("0000000" & Hex$(dw), 8)
End Function

Private Function GiveNiceSize(ByVal sz As Long) As String
    Const OneKilobyte As Long = 1024&
    Const OneMegabyte As Long = 1024& * 1024&
    Const OneGigabyte As Long = 1024& * 1024& * 1024&
    
    Select Case sz
        Case Is < OneKilobyte: GiveNiceSize = sz & " bytes"
        Case Is < OneMegabyte: GiveNiceSize = Format(sz / OneKilobyte, "0 Kb")
        Case Is < OneGigabyte: GiveNiceSize = Format(sz / OneMegabyte, "0.0## Mb")
        Case Else:             GiveNiceSize = Format(sz / OneGigabyte, "0.0## Gb")
    End Select
End Function
